<?php

namespace Drupal\routee_waymore\Form;

use Drupal\Core\Url;
use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;
use Symfony\Component\HttpFoundation\RedirectResponse;

/**
 * Class ConfigurationForm.
 */
class ConfigurationForm extends ConfigFormBase {

    /**
     * {@inheritdoc}
     */
    protected function getEditableConfigNames() {
        return [
            'routee_waymore.configuration',
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function getFormId() {
        return 'routee_waymore_admin_settings_form';
    }

    /**
     * {@inheritdoc}
     */
    public function buildForm(array $form, FormStateInterface $form_state) {
    $form['#attached']['library'][] = 'routee_waymore/global-scripts';
    
    $c = [];
        $defs = \Drupal::service('entity_field.manager')->getFieldMap();
        foreach ($defs as $field_type => $defs1) {
            foreach ($defs1 as $field_type1 => $defs12) {
                $c[] = [
                    "$field_type" => "$field_type1",
                ];
            }
        }
        

        foreach ($c as $k => $val) {
            foreach ($val as $j => $d) {
               
                $k1[$j][$d] = [
                    "select"=>"select",
                    "$d" => "$d",
                ];
                
            }
        }
    
        $config = $this->config('routee_waymore.configuration');
        $config2 = \Drupal::config('routee_waymore.settings');
        $variable_one = $config2->get('variable_one');
//echo $variable_one;
        $form['routee_username'] = [
            '#type' => 'textfield',
            '#title' => $this->t('Routee Username'),
            '#description' => $this->t('Enter routee platform username.'),
            '#default_value' => $config->get('routee_username'),
        ];
        $form['routee_password'] = [
            '#type' => 'password',
            '#title' => $this->t('Routee Password'),
            '#description' => $this->t('Enter routee platform password.'),
            '#default_value' => $config->get('routee_password'),
            '#suffix' => '<br/><div>Don\'t have routee account. <a href="https://go.routee.net/" target="_blank">Register with Routee platform</a>.</div><br/>',
        ];
        $form['optgroup'] = [
            '#type' => 'textfield',
             
        ];
        $form['optgroup_quant'] = [
            '#type' => 'textfield',
             
        ];
        $form['type_options'] = [
            '#type' => 'value',
            '#value' =>$k1, 
            
        ];
         $form['quantity_options'] = [
            '#type' => 'value',
            '#value' =>$k1, 
            
        ];

        $form['entities'] = [
            '#type' => 'select',
            '#title' => $this->t('Select Phone Number field'),
            '#options' => $form['type_options']['#value'],
        ];
      

        return parent::buildForm($form, $form_state);
    }

    /**
     * {@inheritdoc}
     */
    public function validateForm(array &$form, FormStateInterface $form_state) {
        parent::validateForm($form, $form_state);

        $username = $form_state->getValue('routee_username');
        $password = $form_state->getValues('routee_password')['routee_password'];

        if ($username == '') {
            $form_state->setErrorByName('routee_username', t('Please enter username.'));
        }

        if ($password == '') {
            $form_state->setErrorByName('routee_password', t('Please enter password.'));
        }
    }

    /**
     * {@inheritdoc}
     */
    public function submitForm(array &$form, FormStateInterface $form_state) {
        global $base_url;
        $config2 = $this->config('routee_waymore.settings');
        $url = $config2->get('url');
        parent::submitForm($form, $form_state);

        $this->config('routee_waymore.configuration')
                ->set('routee_username', $form_state->getValue('routee_username'))
                ->set('routee_password', $form_state->getValue('routee_password'))
                ->save();

        $username = $form_state->getValue('routee_username');
        $password = $form_state->getValues('routee_password')['routee_password'];
        $entities=$form_state->getValue('entities');
        $quantity=$form_state->getValue('quantity');
        $entities_label=$form_state->getValue('optgroup');
        $quantity_label=$form_state->getValue('optgroup_quant');
        $user = \Drupal::currentUser();
        $userId = $user->id();
        $sid = $_GET['storeid'];
        $uid=$_GET['uid'];
        $drupal_version = \DRUPAL::VERSION;
        $data = array("username" => $username, "password" => $password,
            "source" => "Drupal", "type" => "E-Commerce", "version" => "$drupal_version", "plugin_version" => "1.0.2", "domain" => "$base_url/store/$sid", "currency" => "EUR");
        $data_string = json_encode($data);

        $ch = curl_init('https://waymore.routee.net/api/authenticate');
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json',
            'Content-Length: ' . strlen($data_string))
        );
        $result = curl_exec($ch);
        curl_close($ch);
        $response = json_decode($result);
          // need to change when dev teams is back
//          echo '<pre>';print_r($data_string);die();
//              $t= explode('uuid',$result);
//         $str= str_replace('"','',$t[1]);
//        $str1=str_replace(':', '', $str);
//        $uuid1=str_replace('}', '', $str1);
        if (!empty($response->uuid)) {


            $database = \Drupal::database();
            $result = $database->select('routee_waymore', 'rw')
                    ->fields('rw')
                    ->condition('uid', $userId, "=")
                    ->execute()
                    ->fetchAll();

            $uuid = $response->uuid;
            $time = time();

            $database->insert('routee_waymore')->fields(
                    array(
                        'uid' => $userId,
                        'uuid' => $response->uuid,
                        'username' => $username,
                        'status' => 1,
                        'store_id' => $sid,
                        'created' => $time,
                        'updated' => $time,
                        'phone_field'=>$entities,
                        'phone_table'=>$entities_label,
                    )
            )->execute();
            
 

            $response = new RedirectResponse("$base_url/admin/config/routee_waymore/stores");
            $response->send();
            drupal_set_message(t('Your website is now configured with your routee platform account.'));
        } else {
            drupal_set_message(t('Please enter valid routee username and password. There is not any account associated with the provided details.'), 'error');
        }
    }

}

?>